
From: NeilBrown <neilb@cse.unsw.edu.au>

'this_sector' is a virtual (array) address while 'head_position' is a physical
(device) address, so substraction doesn't make any sense.  devs[slot].addr
should be used instead of this_sector.

However, this patch doesn't make much practical different to the read
balancing due to the effects of later code.

Signed-off-by: Neil Brown <neilb@cse.unsw.edu.au>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 drivers/md/raid10.c |    3 ++-
 1 files changed, 2 insertions(+), 1 deletion(-)

diff -puN drivers/md/raid10.c~md-fix-minor-error-in-raid10-read-balancing-calculation drivers/md/raid10.c
--- devel/drivers/md/raid10.c~md-fix-minor-error-in-raid10-read-balancing-calculation	2005-08-03 22:08:25.000000000 -0700
+++ devel-akpm/drivers/md/raid10.c	2005-08-03 22:08:25.000000000 -0700
@@ -538,7 +538,8 @@ static int read_balance(conf_t *conf, r1
 	}
 
 
-	current_distance = abs(this_sector - conf->mirrors[disk].head_position);
+	current_distance = abs(r10_bio->devs[slot].addr -
+			       conf->mirrors[disk].head_position);
 
 	/* Find the disk whose head is closest */
 
_
